close all;

%DFI SOS - SNR 

Filter=3; % 1 -equalizer , 2 - butterworth LPF, 3 - butterworth HPf,  4 -  elliptic

% Parametric equalizer 
    f0=20;
    Fs=48000;
if Filter == 1
    BW = 0.1;
    gain=-10;
    w0=2.0*pi*f0/Fs;
    alpha = sin(w0)*sinh( log(2)/2 * BW * w0/sin(w0) ) ;

    A=10^(gain/40.0);

    b0 =   1 + alpha*A;
    b1 =  -2*cos(w0);
    b2 =   1 - alpha*A;
    a0 =   1 + alpha/A;
    a1 =  -2*cos(w0);
    a2 =   1 - alpha/A;

    Num=[b0 b1 b2];
    Den=[a0 a1 a2];
elseif Filter==2

    % Butterworth
    [Num,Den]=butter(2,2*pi*f0/Fs); 
elseif Filter==3

    % Butterworth
    [Num,Den]=butter(2,2*pi*f0/Fs,'high'); 

elseif Filter==4
    [Num,Den]=ellip(2,3,60,2*pi*f0/Fs); 
end

figure(1)
N=24;semilogx(logspace(-2,log10(24000),4096),20*log10(abs(freqz(1/(10^((6.02*N)/20)),Den,logspace(-2,log10(24000),4096),48000))));
grid on;
title('Noise spectrum for 24-bit');
figure(2);
SNR=20*log10(abs(freqz(Num,Den,logspace(-2,log10(24000),4096),48000)))-20*log10(abs(freqz(1/(10^((6.02*N)/20)),Den,logspace(-2,log10(24000),4096),48000)));
semilogx(logspace(-2,log10(24000),4096),SNR);
grid on;
title('SNR spectrum for 24-bit');
% figure(3)
% SNR2=6.02*N+20*log10(abs(freqz(Num,1,logspace(-2,log10(24000),4096),48000)));
% semilogx(logspace(-2,log10(24000),4096),SNR2);
% grid on;
% title('SNR2 spectrum for 24-bit');

figure(4)
N=32;semilogx(logspace(-2,log10(24000),4096),20*log10(abs(freqz(1/(10^((6.02*N)/20)),Den,logspace(-2,log10(24000),4096),48000))));
grid on;
title('Noise spectrum for 32-bit');
figure(5);
SNR=20*log10(abs(freqz(Num,Den,logspace(-2,log10(24000),4096),48000)))-20*log10(abs(freqz(1/(10^((6.02*N)/20)),Den,logspace(-2,log10(24000),4096),48000)));
semilogx(logspace(-2,log10(24000),4096),SNR);
grid on;
title('SNR spectrum for 32-bit');
% figure(6)
% SNR2=6.02*N+20*log10(abs(freqz(Num,1,logspace(-2,log10(24000),4096),48000)));
% semilogx(logspace(-2,log10(24000),4096),SNR2);
% grid on;
% title('SNR2 spectrum for 32-bit');

