close all;
clc;

%filtracja metoda modulacji poprawa SNR lub uzycie mniejszej precyzji bitowej

f0=20;
N=16;
Fs=48000;

%filtr wejsciowy slaby SNR 
[Num,Den]=butter(2,2*pi*f0/Fs);
figure(1)
snr_sos(Num,Den,Fs,N);
grid on;

[Num4,Den4]=butter(2,[1/2-2*pi*f0/Fs, 1/2 + 2*pi*f0/Fs]);
figure(2)
snr_sos(Num4,Den4,Fs,N); %SNR DFI bez podzialu na sekcje - slaba poprawa SNR
grid on;

% sygnal wejsciowy

x=sin(((2*pi*f0/2))*linspace(0,2,Fs*2))+sin(((2*pi*f0*16))*linspace(0,2,Fs*2));

% sygnal modulujacy [1,1,-1,-1,....]


smod=sin(2*pi*Fs/4*linspace(0,2-1/Fs,Fs*2))+cos(2*pi*Fs/4*linspace(0,2-1/Fs,Fs*2)); 



xmod=x.*smod; %modulacja

ymod=filter(Num4,Den4,xmod); %filtracja

y=ymod.*(smod); %demodulacja

figure(3)
plot(y)

[SOS,g]=tf2sos(Num4,Den4,'UP',2) %podzial na SOS
grid on;



figure(4)
snr_sos(SOS(2,1:3),SOS(2,4:6),Fs,N); % sekcja decydujaca o SNR
grid on;

SOS(1,1:3) = SOS(1,1:3)
SOS(2,1:3) = SOS(2,1:3)*g  % przeskalowanie sekcji o gain

figure(5)
freqz(SOS(2,1:3),SOS(2,4:6)); % sekcja przeskalowana

figure(6)
snr_sos(SOS(2,1:3),SOS(2,4:6),Fs,N); % sekcja decydujaca o SNR poprawa SNR o ponad 50dB (dla N=16) (!)
grid on;



