% Przyklad 11.2:
% m-plik: przyklad_11_2.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 11: Podstawy artymetyki staloprzecinkowej.
% Autorzy rozdzialu: Wojciech Polchlopek, Roman Rumian, Pawel Turcza.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: marzec 2014 r./WP/RR.

clc; clear; close all;

nb=1; mb=3;                               % liczba bitow przed- i za przecinkiem; 
y_max=2^(nb-1)-2^(-mb); y_min=-2^(nb-1);  % wyznaczamy wartosci: maksymalna i minimalna zakresu;
q=2^(-mb);                                % wyznaczamy krok kwantyzacji;

a=[1, -0.875, 0.625];                     % wspolczynniki mianownika transmitancji filtra [1, -7/8, 5/8];
b=[0,0,1];                                % wspolczynniki licznika transmitancji filtra;
[z,p,K]=tf2zp(b,a);                       % sprawdzamy bieguny filtra (wektor p);
p

x=[0.375, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]; %wymuszenie;
y=[0, 0];                                 % inicjalizacja wektora wyjsciowego;

% filtrowanie:
for n=1:24;
    y0=-a(2)*y(n+1)-a(3)*y(n)+x(n);       % probka wyjsciowa - filtracja;
    if y0>y_max, y0=y_max; elseif y0<y_min, y0=y_min; end; % ograniczenie (nasycenie);
    y(n+2)=round(y0/q)*q;                 % kwantyzacja;
end;

y_test=filter(b,a,x);                     % dla porownania - bez kwantyzacji;
    
    figure(1); n=1:24;
       plot(n,y_test(n),'rx');   grid on;          hold on;
       stem(n,y(n));
            xlabel('n');         ylabel('y(n)');   title('Cykle graniczne');
            legend('bez kwantyzacji','z kwantyzacja');
        
% KONIEC PRZYKLADU 11.2.