% Przyklad 11.3:
% m-plik: przyklad_11_3.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 11: Podstawy artymetyki staloprzecinkowej.
% Autorzy rozdzialu: Wojciech Polchlopek, Roman Rumian, Pawel Turcza.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: marzec 2014 r./WP/RR.

clc; clear; close all;

nb=2; mb=4;                        % liczba bitow przed- i za przecinkiem; 
q=2^(-mb);                         % krok kwantyzacji;
a1=-2^(nb-1):q:2^(nb-1)-q;         % mozliwe wartosci wspolczynnika a1 po kwantyzacji;
a2=-2^(nb-1):q:2^(nb-1)-q;         % mozliwe wartosci wspolczynnika a2 po kwantyzacji;

mm = 1;
zakres = 0;
for na1=1:length(a1),
    for na2=1:length(a2),
        
        a=[1, a1(na1), a2(na2)];    % wektor wspolczynnikow mianownika transmitancji filtra;
        pp = roots(a);              % oblicz pierwiastki (bieguny);
        
        if (max(abs(pp)) < 1-eps),  % sprawdz warunek stabilnosci (z zapasem rownym zmiennej wbudowanej "eps");
            p(mm)= pp(1);
            mm = mm + 1;
            p(mm)= pp(2);
            mm = mm + 1;
        end;
        
    end;
end;

    figure(1);   h=gcf;   close(h); % przygotowanie rysunku dla "zplane(0,0,1)";
        zplane(0,0,1);    hold on;
        plot(p,'b.');

% KONIEC PRZYKLADU 11.3.