% Przyklad 11.4:
% m-plik: przyklad_11_4.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 11. Podstawy arytmetyki staloprzecinkowej. 
% Autorzy rozdzialu:  Wojciech Polchlopek, Roman Rumian, Pawel Turcza.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2014 r./WP/RR.

clc; clear; close all;

mb=5;                    % liczba bitow za przecinkiem (przed przecinkiem z zalozenia jest 1 bit);
q=2^(-mb);
Re_a1=-1:q:1-q;          % wynikajace z kwantyzacji mozliwe wartosci czesci rzeczywistej wspolczynnika a1;
Im_a1=-1:q:1-q;          % wynikajace z kwantyzacji mozliwe wartosci czesci urojonej wspolczynnika a1;

mm = 1;
zakres = 0;
for n_Re=1:length(Re_a1),
    for n_Im=1:length(Im_a1),
        
        p0=Re_a1(n_Re)+i*Im_a1(n_Im);
        
        if (abs(p0) < 1-eps), % sprawdzanie warunku stabilnosci;
            p(mm)=p0; 
            mm = mm + 1;
        end;
        
    end;
end;

% rysowanie wyniku:
    figure(1);     h=gcf;   close(h);  % przygotowanie rysunku dla "zplane(0,0,1)";
        zplane(0,0,1);      hold on;   
        plot(p,'b.');

% KONIEC PRZYKLADU 11.4.